package ch.zhaw.prog2.heartbeat;

import org.junit.jupiter.api.Test;
import org.mockito.Mock;

import static org.junit.jupiter.api.Assertions.*;

/*
 * Test Class for Pacemaker
 */
public class PacemakerTest {

    @Mock
    Pacemaker pacemaker = new Pacemaker(new Heart());

    /**
     * Test if setHeartRate does throw correct exception when rate is rejected (because frequency is out of range)
     */
    @Test
    void testSetHeartRateRejectsFrequenciesOutOfRange() {
        //TODO implement
        for(int i = -10; i < 29; i ++){
            int finalI = i;
            assertThrows(IllegalArgumentException .class, // verification using lambda
                () -> pacemaker.setHeartRate(finalI));
        }
        for(int i = 221; i < 230; i ++){
            int finalI1 = i;
            assertThrows(IllegalArgumentException .class, // verification using lambda
                () -> pacemaker.setHeartRate(finalI1));
        }
    }


    /**
     * Test if setHeartRate does correctly set the rate when frequency is inside range
     */
    @Test
    void testSetHeartRateAppliesFrequenciesInsideRange() {
        //TODO implement
        for(int i = 30; i <= 220; i ++){
            assertEquals(i, pacemaker.setHeartRate(i));
        }
    }

}
